## golang-code.forgejo-f3-gof3 3.11.0

=== Makefile ===
GO ?= $(shell go env GOROOT)/bin/go

DIFF ?= diff --unified

EDITORCONFIG_CHECKER_PACKAGE ?= github.com/editorconfig-checker/editorconfig-checker/v3/cmd/editorconfig-checker@v3.3.0 # renovate: datasource=go
GOFUMPT_PACKAGE ?= mvdan.cc/gofumpt@v0.8.0 # renovate: datasource=go
GOLANGCI_LINT_PACKAGE ?= github.com/golangci/golangci-lint/v2/cmd/golangci-lint@v2.1.6 # renovate: datasource=go
UNCOVER_PACKAGE ?= github.com/gregoryv/uncover/cmd/uncover@latest
MISSPELL_PACKAGE ?= github.com/golangci/misspell/cmd/misspell@v0.7.0 # renovate: datasource=go
DEADCODE_PACKAGE ?= golang.org/x/tools/cmd/deadcode@v0.33.0 # renovate: datasource=go
GOMOCK_PACKAGE ?= go.uber.org/mock/mockgen@v0.5.2 # renovate: datasource=go

SCHEMAS_VERSION ?= v4

DEADCODE_ARGS ?= -generated=false -test -f='{{println .Path}}{{range .Funcs}}{{printf "\t%s\n" .Name}}{{end}}{{println}}' code.forgejo.org/f3/gof3/v3/...

VERSION ?= $(shell git describe --tags --always | sed 's/-/+/' | sed 's/^v//')

LDFLAGS := $(LDFLAGS) -X "code.forgejo.org/f3/gof3/v3/cmd.Version=$(VERSION)"

EXECUTABLE := f3-cli

GO_DIRS = cmd f3 forges logger main options tree util
GO_SOURCES = $(shell find $(GO_DIRS) -type f -name "*.go")

$(EXECUTABLE): $(GO_SOURCES)
	$(GO) build -tags 'netgo osusergo' -ldflags '-extldflags -static -s -w $(LDFLAGS)' -o $@ code.forgejo.org/f3/gof3/v3/main

.PHONY: deps-backend
deps-backend:
	$(GO) mod download
	$(GO) install $(GOFUMPT_PACKAGE)
	$(GO) install $(EDITORCONFIG_CHECKER_PACKAGE)
	$(GO) install $(GOLANGCI_LINT_PACKAGE)
	$(GO) install $(UNCOVER_PACKAGE)
	$(GO) install $(MISSPELL_PACKAGE)
	$(GO) install $(DEADCODE_PACKAGE)
	$(GO) install $(GOMOCK_PACKAGE)

.PHONY: lint
lint:
	@if ! $(MAKE) lint-run ; then echo "Please run 'make lint-fix' and commit the result" ; exit 1 ; fi

.PHONY: lint-run
lint-run: lint-schemas lint-editorconfig
	$(GO) run $(GOLANGCI_LINT_PACKAGE) run $(GOLANGCI_LINT_ARGS)
	$(GO) run $(DEADCODE_PACKAGE) $(DEADCODE_ARGS) > .cur-deadcode-out
	$(DIFF) .deadcode-out .cur-deadcode-out

.PHONY: lint-editorconfig
lint-editorconfig:
	$(GO) run $(EDITORCONFIG_CHECKER_PACKAGE) --exclude '.*~$$' .forgejo/workflows

.PHONY: lint-schemas
lint-schemas:
	status=0 ; for schema in f3/schemas/*.json ; do if ! jq '.|empty' $$schema ; then status=1 ; echo $$schema error ; fi ; done ; exit $$status
	d=`mktemp -d` ; trap "rm -fr $$d" EXIT ; git clone --quiet https://code.forgejo.org/f3/f3-schemas $$d/schemas ; ( cd $$d/schemas ; git checkout --quiet $(SCHEMAS_VERSION) ) ; diff --exclude '.*' -ru $$d/schemas f3/schemas

.PHONY: lint-schemas-fix
lint-schemas-fix:
	d=`mktemp -d` ; trap "rm -fr $$d" EXIT ; git clone --quiet https://code.forgejo.org/f3/f3-schemas $$d/schemas ; ( cd $$d/schemas ; git checkout --quiet $(SCHEMAS_VERSION) ) ; cp $$d/schemas/* f3/schemas

.PHONY: lint-fix
lint-fix: lint-schemas-fix
	$(GO) run $(GOLANGCI_LINT_PACKAGE) run $(GOLANGCI_LINT_ARGS) --fix
	$(GO) run $(DEADCODE_PACKAGE) $(DEADCODE_ARGS) > .deadcode-out

.PHONY: fmt
fmt:
	GOFUMPT_PACKAGE=$(GOFUMPT_PACKAGE) gofumpt -extra -w .

SPELLCHECK_FILES = $(GO_DIRS)

.PHONY: lint-spell
lint-spell:
	@$(GO) run $(MISSPELL_PACKAGE) -error $(SPELLCHECK_FILES)

.PHONY: lint-spell-fix
lint-spell-fix:
	@$(GO) run $(MISSPELL_PACKAGE) -w $(SPELLCHECK_FILES)

=== debian/changelog ===
golang-code.forgejo-f3-gof3 (3.11.0-1) experimental; urgency=medium

  * Initial release (Closes: #1109522)

 -- Maytham Alsudany <maytham@debian.org>  Sat, 19 Jul 2025 20:29:20 +0800

=== debian/control ===
Source: golang-code.forgejo-f3-gof3
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Maytham Alsudany <maytham@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-golang,
 golang-any,
 golang-github-urfave-cli-v3-dev,
 golang-github-santhosh-tekuri-jsonschema-dev (>= 6),
 golang-github-hashicorp-go-version-dev,
 golang-github-42wim-httpsig-dev,
 golang-golang-x-crypto-dev,
 golang-gitlab-gitlab-org-api-client-go-dev,
 golang-github-google-go-cmp-dev,
 golang-github-stretchr-testify-dev <!nocheck>,
 git <!nocheck>,
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/golang-code.forgejo-f3-gof3
Vcs-Git: https://salsa.debian.org/go-team/packages/golang-code.forgejo-f3-gof3.git
Homepage: https://code.forgejo.org/f3/gof3
XS-Go-Import-Path: code.forgejo.org/f3/gof3

Package: golang-code.forgejo-f3-gof3-dev
Architecture: all
Multi-Arch: foreign
Depends:
 golang-github-urfave-cli-dev,
 golang-github-santhosh-tekuri-jsonschema-dev,
 golang-github-hashicorp-go-version-dev,
 golang-github-42wim-httpsig-dev,
 golang-golang-x-crypto-dev,
 golang-gitlab-gitlab-org-api-client-go-dev,
 golang-github-google-go-cmp-dev,
 ${misc:Depends},
Description: tool to convert between projects in a forge and the F3 format (library)
 Convert between projects in a forge and the Friendly Forge Format, allowing
 projects to be mirrored.
 .
 This package contains the gof3 library.

Package: f3-cli
Section: vcs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Static-Built-Using: ${misc:Static-Built-Using}
Description: tool to convert between projects in a forge and the F3 format (program)
 Convert between projects in a forge and the Friendly Forge Format, allowing
 projects to be mirrored.
 .
 This package contains the f3-cli program.

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_INSTALL_EXTRA := f3/file_format_testdata f3/schemas

%:
	dh $@ --builddirectory=debian/build --buildsystem=golang

execute_after_dh_auto_build:
	mv $(CURDIR)/debian/build/bin/main $(CURDIR)/debian/build/bin/f3-cli

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
  https://code.forgejo.org/f3/gof3.git \
  refs/tags/v?(\d[\d\.]*)
